//
// H쐬̃R[fBOɂāA@zurazurataichoĺuCŌ@@gH쐬Ă݂v𗬗pĂ܂B
// https://qiita.com/zurazurataicho/items/1435b7236b6b1ca34334
//

#include "stdafx.h"

#include <time.h>
#include <conio.h>

#include "misc.h"

#include "map.h"
#include "gameType.h"
#include "time.h"
#include "nextStage.h"

#define SPACE 0x20

typedef enum {
	eWALL,	// 
	eROAD,	// 
	eCHAR,	// L
	eGOAL,	// S[
	eSTAR,	// 
	eCLOCK,
} CHIP;

typedef struct {
	int x;
	int y;
} POINT;

typedef struct {
	int stage;
	int starNum;
} PARAM;

static const PARAM kParam[] = {
	{ 1, 3},
	{ 2, 4},
	{ 3, 5},
};

// map̕ABɂ邱
#define W (35)
#define H (21)

// }bv
static CHIP map[H][W];

// Lx,yW
static int s_charX;
static int s_charY;

// S[x,yW
static int s_goalX;
static int s_goalY;

static int starLength;

// 4ɍ킹Đix,y̒l

static const POINT kDir[] = {
	{ 0, -1 },	// 
	{ 1, 0 },	// E
	{ 0, 1 },	// 
	{ -1, 0 }	// 
};

// Ǘ\
static POINT s_star[5];

// Ǘ\
typedef struct {
	int x;
	int y;
} CLOCK;
static CLOCK s_clock[2];

// J[\sɈڂ
static void topLineCursor() {
	printf("\x1b[1G");
}

// J[\ʐ擪ɖ߂
static void topScreenCursor() {
	printf("\x1b[1;1H");
}

// ̗
static int randOdd(int mod) {
	int r = 1 + (rand() % mod);
	if (r % 2 == 0) {
		r++;
	}
	if (mod < r) {
		r = mod - 1;
	}
	return r;
}

// H
static void makeMaze(int x, int y) {
	const int DIR_MAX = 4;
	int dirStart = rand() % DIR_MAX;
	int d = dirStart;

	while (1) {
		int nx = x + (kDir[d].x * 2);
		int ny = y + (kDir[d].y * 2);
		if (nx < 0 || W <= nx
		 || ny < 0 || H <= ny
		 || map[ny][nx] != eWALL) {
			d++;
			d %= DIR_MAX;
			if (d == dirStart) {
				return;
			}
			continue;
		}
		map[y + kDir[d].y][x + kDir[d].x] = eROAD;
		map[ny][nx] = eROAD;
		makeMaze(nx, ny);
		dirStart = rand() % DIR_MAX;
		d = dirStart;
	}
}

// l̂ԉS[ɂ
static void findGoal(int x, int y, int *pGx, int *pGy) {
	typedef struct {
		int x;
		int y;
	} GOAL;
	const GOAL kGoal[] = {
		{ 1, 1 },						// 
		{ (W - 1) - 1, 1 },				// E
		{ (W - 1) - 1, (H - 1) - 1 },	// E
		{ 1, (H - 1) - 1 }				// 
	};
	int i, maxIdx;
	int distance, maxDistance;

	maxIdx = 0;
	maxDistance = 0;
	for (i = 0; i < ARRAYOF(kGoal); i++) {
		distance = ((x - kGoal[i].x) * (x - kGoal[i].x))
			+ ((y - kGoal[i].y) * (y - kGoal[i].y));
		if (maxDistance < distance) {
			maxDistance = distance;
			maxIdx = i;
		}
	}
	*pGx = kGoal[maxIdx].x;
	*pGy = kGoal[maxIdx].y;
}

// zu
static void setupStar() {
	int i;
	int x, y;

	for (i = 0; i < ARRAYOF(kParam); i++) {
		if (kParam[i].stage == getStage()) {
			starLength = kParam[i].starNum;
		}
	}

	for (i = 0; i < starLength; i++) {
		do {
			x = rand() % W;
			y = rand() % H;
		} while (map[y][x] != eROAD);
		s_star[i].x = x;
		s_star[i].y = y;
		map[s_star[i].y][s_star[i].x] = eSTAR;
	}
}

// zu
void setupClock() {
	int i;
	int x, y;

	for (i = 0; i < ARRAYOF(s_clock); i++) {
		do {
			x = rand() % W;
			y = rand() % H;
		} while (map[y][x] != eROAD);
		s_clock[i].x = x;
		s_clock[i].y = y;
		map[s_clock[i].y][s_clock[i].x] = eCLOCK;
	}
}

// }bv
void setupMap() {
	int y, x;

	// eWALLŏ
	for (y = 0; y < H; y++) {
		for (x = 0; x < W; x++) {
			map[y][x] = eWALL;
		}
	}

	// H
	x = randOdd(W - 2);
	y = randOdd(H - 2);
	makeMaze(x, y);

	// X^[g߂
	s_charX = x;
	s_charY = y;
	map[s_charY][s_charX] = eCHAR;

	// S[߂
	findGoal(x, y, &s_goalX, &s_goalY);
	map[s_goalY][s_goalX] = eGOAL;

	// zu
	setupStar();
	// zu
	setupClock();
}

// \ʂftHgɖ߂
static void clearEffect() {
	printf("\x1b[0m");
}

// ǂ\
static void displayWall() {
	printf("");
}
// \
static void displayRoad() {
	printf("@");
}
// L\
static void displayChar() {
	printf("\x1b[32m");	// 
	printf("");
}
// S[\
static void displayGoal() {
	printf("\x1b[34m");	// 
	printf("");
}
// \
static void displayStar() {
	printf("\x1b[33m");	// 
	printf("");
}
// \
static void displayClock() {
	printf("\x1b[31m");	// 
	printf("");
}

// `bv\
static void displayChip(CHIP c) {
	typedef struct {
		CHIP c;
		void(*pDisplay)();
	} DISPLAY;
	const DISPLAY kDisplay[] = {
		{ eWALL, displayWall },	// 
		{ eROAD, displayRoad },	// 
		{ eCHAR, displayChar },	// L
		{ eGOAL, displayGoal },	// S[
		{ eSTAR, displayStar },	// 
		{ eCLOCK, displayClock }, // 
	};
	int i;

	for (i = 0; i < ARRAYOF(kDisplay); i++) {
		if (kDisplay[i].c == c) {
			(*kDisplay[i].pDisplay)();
			clearEffect();
			return;
		}
	}
}

// }bvʂ\
static void displayMap() {
	int y, x;

	// map`
	for (y = 0; y < H; y++) {
		for (x = 0; x < W; x++) {
			displayChip(map[y][x]);
		}
		printf("\n");
	}
}

// c̃X^[̐Ԃ
static int remainingStar() {
	int i;
	int num = 0;

	for (i = 0; i < starLength; i++) {
		if (map[s_star[i].y][s_star[i].x] == eSTAR) {
			num++;
		}
	}

	return num;
}

// c̃X^[̐\
void displayRemainingStar() {
	printf("    cX^[ : %d", remainingStar());
}

// ̃Xe[W\
void displayStage() {
	printf("    Xe[W : %d", getStage());
}

//NAǂ`FbN
static int clearCheck() {
	if (s_goalX == s_charX && s_goalY == s_charY) {
		if (remainingStar() == 0) {
			// NA
			return 1;
		}
	}
	return 0;
}

// LړłȂړ
static void moveChar(int keyCode) {
	typedef struct {
		int keyCode;
		const POINT *pDir;
	} MOVE;
	const MOVE kMove[] = {
		{ 'w', &kDir[0] },	// 
		{ 'd', &kDir[1] },	// E
		{ 's', &kDir[2] },	// 
		{ 'a', &kDir[3] }	// 
	};
	int i;
	int x, y;

	for (i = 0; i < ARRAYOF(kMove); i++) {
		if (keyCode == kMove[i].keyCode) {
			break;
		}
	}
	if (i == ARRAYOF(kMove)) {
		return;
	}

	x = s_charX + kMove[i].pDir->x;
	y = s_charY + kMove[i].pDir->y;
	if (map[y][x] == eWALL) {
		return;	// ړȂ
	}

	if (map[y][x] == eCLOCK) {
		extendedTime();
	}

	// 𓹂ɒuĈړɕς
	map[s_charY][s_charX] = eROAD;
	s_charX = x;
	s_charY = y;
	map[s_charY][s_charX] = eCHAR;

	//LƃS[dȂĂȂ̂ɃS[ȂƂ
	if (!(s_goalX == s_charX && s_goalY == s_charY)) {
		if (map[s_goalY][s_goalX] != eGOAL) {
			map[s_goalY][s_goalX] = eGOAL;
		}
	}
	return;
}

// Q[ʂ𑀍삷
GmType gameDisplay() {
	char ch;

	displayMap();

	while (1) {

		// KCh\XV
		countSec();

		topLineCursor();
		displaySec();
		displayRemainingStar();
		displayStage();

		if (getCountSec() <= 0) {
			printf("\n");
			return GM_TIMEOVER;
		}

		if (_kbhit()) {
			ch = _getch();
			if (ch == SPACE) {
				return GM_MENU;
			}

			// LړłȂړ
			moveChar(ch);

			topScreenCursor();

			displayMap();

		}
		// Q[NAǂ`FbN
		if (clearCheck() == 1) {
			if (getStage() == 3) {
				return GM_CLEAR;
			}

			return GM_STAGECLEAR;
		}
	}
}